//+------------------------------------------------------------------+
//|                                                    Code Test.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


extern int slippage               = 2;
extern int trailingstop           = 0;
extern double takeprofit          = 120;  
extern double stoploss            = 30;
extern double lots                = 1;
extern double minutestime         = 300;
extern string nameEA              = "Code Test";
extern double equitypercent       = 0.02;
extern int    SL_ATR              = 1;
extern int    TP_ATR              = 1;
extern int    MA1                 = 8;
extern int    MA2                 = 21;
extern int    MA3                 = 55;

//Other Declaration

double realSL, realTP, ATR, ATRSTOP;
double ma1, ma2, ma3,ma1p,ma2p,ma3p, PSAR1, PSAR2, PSAR3;
bool BUYING, SELLING, I1, I2, I3, I4, HGC, CGC, CGC1, indicatorsignalBUY, indicatorsignalSELL;
double OOP30,OOP60,OOP90,OOP120, SOOP30, SOOP60, SOOP90, SOOP120, ATRSTOPV, Ordertest;
int trailsequencer,bb,ss,pp,c1,c2,c3;

double dollarrisk,riskperpip,maxlots,minlots,SL_ATR_PLUG, TP_ATR_PLUG;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
 {    
   maxlots = MarketInfo("EURUSD",MODE_MAXLOT);
    minlots = MarketInfo("EURUSD",MODE_MINLOT);
    
   if(stoploss >0)
      {
      dollarrisk= equitypercent*AccountEquity();
      riskperpip=dollarrisk/stoploss;
      lots=riskperpip/10;     
      }
    else 
      {
      if(SL_ATR_PLUG >0)
         {
         SL_ATR_PLUG=SL_ATR_PLUG*10000;
         dollarrisk= equitypercent*AccountEquity();
         riskperpip=dollarrisk/SL_ATR_PLUG;
         lots=riskperpip/10;
         }
         
      }
       
    if(lots > maxlots)
    {
      lots = maxlots;
    }
    
    if(lots < minlots)
    {
      lots = minlots;
    }
 

calculateIndicators(); 
int totalOrders = OrdersTotal();
int numPos, ticket, cnt;
    
ATRSTOP= Ask - (ATR*3); 
ATRSTOPV =Ask - (ATR*2);

if(totalOrders >0)
{
SOOP30=  OrderOpenPrice() - 30*Point;
SOOP60=  OrderOpenPrice() - 60*Point;
SOOP90=  OrderOpenPrice() - 90*Point;
SOOP120= OrderOpenPrice() - 120*Point; 

OOP30=  OrderOpenPrice() + 30*Point;
OOP90=  OrderOpenPrice() + 90*Point;
OOP60=  OrderOpenPrice() + 60*Point;
OOP120= OrderOpenPrice() + 120*Point; 
}


//++--------------------------------------------------------------------------------------------------++
//start loop checking for closing positions    
  //pp++;Print("pp-",pp);
  for(cnt =0; cnt < totalOrders; cnt++)
    {//2
      OrderSelect(cnt, SELECT_BY_POS);
      
      if(OrderSymbol() == Symbol() && OrderType() <= OP_SELL && OrderComment() == nameEA)
         {
                numPos++;
            //check for closing short positions
            if(OrderType()== OP_SELL && Bid < SOOP30)//If we have a short position and the current profit is greater than 30 pips. Pass to switch
                   { //4                                                                 
                      //ss++;Print("ss-",ss);
                      RefreshRates();
                      switch(trailsequencer)
                         {                              
                            case 1 :                      
                                while(Bid > SOOP60 && OrdersTotal() > 0 && ma1 != ma1p)
                                 {
                                 checkstop1();
                                 break;
                                 }                                 
                            trailsequencer++;
                            break;      
                                                                                       
                             case 2 :             
                                 while (Bid > SOOP90 && OrdersTotal() > 0)
                                  {
                                    if(NormalizeDouble(ma2,4) != NormalizeDouble(OrderStopLoss(),4))
                                     {
                                     OrderModify(OrderTicket(),OrderOpenPrice(),ma2, OrderTakeProfit(),0,Blue);
                                      Print("stoploss",DoubleToStr(OrderStopLoss(),Digits));
                                      Print("ma3",DoubleToStr(ma3,Digits));
                                      Sleep(5000); 
                                     }
                                    break;
                                  }
                                  
                                    
                                   trailsequencer++;
                                   break;        
                                        
                            case 3 : 
                                while(Bid > SOOP120 && OrdersTotal() > 0)
                                  {
                                  
                                   if(NormalizeDouble(ma1,4) != NormalizeDouble(OrderStopLoss(),4))
                                       {
                                       OrderModify(OrderTicket(),OrderOpenPrice(),ma1, OrderTakeProfit(),0,Blue);
                                       Print("stoploss",DoubleToStr(OrderStopLoss(),Digits));
                                       Print("ma3",DoubleToStr(ma3,Digits));
                                       Sleep(5000); 
                                       }
                                  }
                               break;
                          }//4
                      }//3   
                      
             else  
                     {//4                       
                        if(OrderType()== OP_BUY && Ask > OOP30)                                     
                              {//5
                         //bb++;Print("bb-",bb,"tr-",trailsequencer);
                         RefreshRates();
                         switch(trailsequencer)                    
                                 { //6                             
                                    case 1 :                                                 
                                       while(Ask < OOP60 && OrdersTotal() > 0)
                                        {//7
                                          if(NormalizeDouble(ma3,4) != NormalizeDouble(OrderStopLoss(),4))                  
                                           {//8
                                            Print("Bid - ",MarketInfo(OrderSymbol(),MODE_BID)," type - ",OrderType()," stop - ",OrderStopLoss()," newstop - ",ma3);
     
                                            OrderModify(OrderTicket(),OrderOpenPrice(),ma3, OrderTakeProfit(),0,Blue);
                                            break;
                                           }  //7
                                         }  
                                          //c1++;Print("c1-",c1);
                                        trailsequencer++;                
                                        break;                                                            
                     
                                     case 2 :                        
                                       while(Ask < OOP90 && OrdersTotal () > 0)
                                        {//7
                                          if(NormalizeDouble(ma2,4) != NormalizeDouble(OrderStopLoss(),4))
                                             {//8
                                             Print("Bidbuy1 - ",MarketInfo(OrderSymbol(),MODE_BID)," type - ",OrderType()," stop - ",OrderStopLoss()," newstop - ",ma2);
     
                                             OrderModify(OrderTicket(),OrderOpenPrice(),ma2, OrderTakeProfit(),0,Blue);
                                             break;
                                             }//7
                                         }
                                         //c2++;Print("c2-",c2);

                                             trailsequencer++;
                                             break;   
                                                                                                         
                                       case 3 : 
                                       while(Ask < OOP120)
                                        {//7
                                          if(NormalizeDouble(ma1,4) != NormalizeDouble(OrderStopLoss(),4))
                                          {//8
                                          Print("Bidbuy2 - ",MarketInfo(OrderSymbol(),MODE_BID)," type - ",OrderType()," stop - ",OrderStopLoss()," newstop - ",ma1);
     
                                          OrderModify(OrderTicket(),OrderOpenPrice(),ma1, OrderTakeProfit(),0,Blue);
                                          break;
                                          }//7
                                        else break;
                                        }//6
                                        //c3++;Print("c3-",c3);
                                        break;

                                }//5
                            }//4
                       }//3                      
                   }//2
              }//1
              
                                                                                                                   
if(totalOrders < 1)

  {
    if(AccountFreeMargin() < 1000*lots)   
      {
         Print("Not enough Free Margin to trade with this lot size");
         return(0);
      }

    if(BUYING && !SELLING)
    
        {        
               if(stoploss < 1)
                  realSL = NormalizeDouble(Ask,4) - SL_ATR_PLUG;
               else
                  realSL = Ask-stoploss*Point;                                              
               if(takeprofit < 1)
                  realTP = NormalizeDouble(Ask,4) + TP_ATR_PLUG;
               else  
                  realTP =Ask+takeprofit*Point;

               ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, slippage, realSL, realTP, nameEA, 16384,0,Red);
                    
                    Print("ATR(",ATR); 
                    Print("SL_ATR(",SL_ATR);
                    Print("SL_ATR_PLUG(",SL_ATR_PLUG);
                    Print("TP_ATR(",TP_ATR);
                    Print("TP_ATR_PLUG(",TP_ATR_PLUG);
                    Print("realSL(",realSL);
                    Print("realTP(",realTP);
                    Print("dollarrisk (",dollarrisk);
                    Print("riskperpip (",riskperpip);
                    Print("lots (",lots);

            
            trailsequencer = 1;
                 
            if(ticket < 0)
            Print("OrderSend (",nameEA,") failed with error #", GetLastError());
            Alert("CODE_TEST: BUY BUY BUY");
            
         }

      if(SELLING && !BUYING)
         {
               if(stoploss < 1)
                  realSL = NormalizeDouble(Bid,4) + SL_ATR_PLUG;
               else
                  realSL = Bid + stoploss * Point;                    
               if(takeprofit < 1)
                  realTP = NormalizeDouble(Bid,4) - TP_ATR_PLUG;
               else  
                  realTP = Bid - takeprofit * Point;
               
               ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, slippage, realSL, realTP, nameEA, 16384, 0, Red);
               
                    Print("ATR(",ATR); 
                    Print("SL_ATR(",SL_ATR);
                    Print("SL_ATR_PLUG(",SL_ATR_PLUG);
                    Print("TP_ATR(",TP_ATR);
                    Print("TP_ATR_PLUG(",TP_ATR_PLUG);
                    Print("realSL(",realSL);
                    Print("realTP(",realTP);
                    Print("dollarrisk (",dollarrisk);
                    Print("riskperpip (",riskperpip);
                    Print("lots (",lots);
            
            trailsequencer = 1;  
                          
            if(ticket < 0)
            Print ("OrderSend (",nameEA,")failed with error #", GetLastError());
            Alert("Code_TEST: SELL SELL SELL");
          
          }
        return(0);
        
       }
    }
  


void calculateIndicators() 
  {
  
ma1            = iMA(NULL, 0, MA1, 0, MODE_EMA, PRICE_CLOSE,0);
ma2            = iMA(NULL, 0, MA2, 0, MODE_EMA, PRICE_CLOSE,0);
ma3            = iMA(NULL, 0, MA3, 0, MODE_EMA, PRICE_CLOSE,0);

ma1p           = iMA(NULL, 0, MA1, 0, MODE_EMA, PRICE_CLOSE,1);
ma2p           = iMA(NULL, 0, MA2, 0, MODE_EMA, PRICE_CLOSE,1);
ma3p           = iMA(NULL, 0, MA3, 0, MODE_EMA, PRICE_CLOSE,1);

ATR            = iATR(NULL, 0, 21, 0); 
PSAR1          = iSAR(0, PERIOD_H1, .02, .2, 0);

BUYING = (ma1 > ma2 && ma2 > ma3);

SELLING = (ma3 > ma2 && ma2 > ma1);

SL_ATR_PLUG                 =NormalizeDouble(ATR*SL_ATR,4); 
TP_ATR_PLUG                 =NormalizeDouble(ATR*TP_ATR,4); 


   }
   

void checkstop1()
{

if(NormalizeDouble(ma3,4) != NormalizeDouble(OrderStopLoss(),4))
   {
      Print("Bid - ",MarketInfo(OrderSymbol(),MODE_BID)," type - ",OrderType()," stop - ",OrderStopLoss()," newstop - ",ma3);
      if(OrderModify(OrderTicket(),OrderOpenPrice(),ma3, OrderTakeProfit(),0,Blue))Print ("Good");   
                            
      //Print("stoploss",DoubleToStr(OrderStopLoss(),Digits));
      //Print("ma3",DoubleToStr(ma3,Digits));
      Sleep(5000);
   }

}